// 7practices.as

/* ---------------- INCLUDE LIBRARIES ------------------- */

#include "code/MovieClip_extensions.as"
#include "code/Array_extensions.as"
#include "code/TextField_extensions.as"
#include "code/color_extensions.as"
#include "code/easing.as"
#include "code/Answerbox.as"
#include "code/Buttonbox.as"
#include "code/event_queue.as"

/* ---------------- DECLARATION ------------------- */

// _root variables

var debug = true;

_global.jdgButtonHold = false;
var depthCount = 50;
var attachedMcs = [];
var hiddenBoxMcs = [];
var buttonBlinkRate = 500; //ms
var swfRoot = _root;
var firstPlay = true;
var turnInProgress = false;
var faceFlashRate = 900; //ms
var xmlFileName = '7practicas_quizdata';

var questionCount = 7;

var playerMisses, currentQuestion;

var quboxPos = [64,42];

var boxStart = [45,50];
var boxSpacing = [140,113];

var continueButtonPos = [178,339];

var questionTextPadding = 22;
var answerTextPadding = 6;

var answerBoxYSpacing = 8;
var answerBoxIndent = 24;

var soundPlaying = false;
var fadedSoundVolume = 10;
var soundFadeDuration = 31;
var restartSoundOnReplay = true;

//                     [normal,   rollover, dead,     correct/selected, incorrect/selected, correct/unselected]
var ansboxBgColors =   [0xffffff, 0xffffff, 0xffffff, 0x8cc63f,         0xfc851f,           0xffffff];
var ansboxOlColors =   [0x555555, 0xaaaaaa, 0x9d9fa1, 0x6c9d31,         0xbf4d27,           0x6c9d31];
var ansboxTextColors = [0x000000, 0x000000, 0x9d9fa1, 0xFFFFFF,         0xFFFFFF,           0x6c9d31];

// [normal, rollover, dead]
var barbtnBgColors = [0x8ED8F8,0x8ED8F8,0x3789CC];
var barbtnOlColors = [0xFFFFFF,0xbf4d27,0xFFFFFF];
var barbtnTextColors = [0xFFFFFF,0xFFFFFF,0xFFFFFF];

// [normal, rollover, dead]
var contbtnBgColors = [0xeeeeee,0xeeeeee,0xeeeeee];
var contbtnOlColors = [0x555555,0xaaaaaa,0xaaaaaa];
var contbtnTextColors = [0x555555,0x555555,0x555555];

var ansboxTf = new TextFormat();
ansboxTf.align = 'left';
ansboxTf.font = 'f_TheSansBold';
ansboxTf.size = 12;
ansboxTf.color = 0x000000;

var ansboxBoolTf = new TextFormat();
ansboxBoolTf.align = 'center';
ansboxBoolTf.font = 'f_TheSansBold';
ansboxBoolTf.size = 12;
ansboxBoolTf.color = 0x000000;

var questionTf = new TextFormat();
questionTf.align = 'left';
questionTf.font = 'f_TheSansBold';
questionTf.size = 13;
questionTf.color = 0xbf272d;

var explanationTf= new TextFormat();
explanationTf.align = 'left';
explanationTf.font = 'f_TheSansBold';
explanationTf.color = 0x000000;
explanationTf.size = 12;

var ansboxItalicTf = new TextFormat ();
ansboxItalicTf.font = 'f_TheSansBoldItalic';

var questionItalicTf = new TextFormat ();
questionItalicTf.font = 'f_TheSansBoldItalic';

var explanationItalicTf = new TextFormat ();
explanationItalicTf.font = 'f_TheSansBoldItalic';

/* ---------------- SOUNDS ------------------- */

var queuedSound;
var soundLoadQueue = [];
var soundList = [];
loadQueuedSound = function() {
	debug_trace('loaded queuedSound: ' + _root.queuedSound.sourcename);
	if (_root.queuedSound.ambient) {
//		_root.queuedSound.start(0,1000);
//		_root.queuedSound.playing = true;
	}
	if (_root.soundLoadQueue.length > 0) {
		debug_trace('soundLoadQueue.length: ' + _root.soundLoadQueue.length);
		var qs = _root.soundLoadQueue.pop();
		_root.queuedSound = qs;
		if (qs.external) {
			debug_trace('loading queuedSound: ' + qs.sourcename);
			qs.onLoad = _root.loadQueuedSound;
			qs.loadSound(qs.sourcename);
		} else {
			debug_trace('attaching queuedSound: ' + qs.sourcename);
			qs.attachSound(qs.sourcename);
			_root.loadQueuedSound();
		}
	}
}

// soundList [id, sourcename, external, looping, ambient, fadeVolume]

soundList.push(['rhythm','game_loop.mp3',true,true,true,20]);
soundList.push(['ending','game_ending.mp3',true,false,false,100]);
soundList.push(['correct','s_correct',false,false,false,100]);
soundList.push(['incorrect','s_incorrect',false,false,false,100]);
soundList.push(['startScreen','s_startScreen',false,false,false,100]);

// soundList.push(['cello','wireless_cello_loop.mp3',true,true,true,0]);
// soundList.push(['clarinet','wireless_clarinet_loop.mp3',true,true,true,0]);
// soundList.push(['question','s_question',false,false,false]);
// soundList.push(['appear','s_appear',false,false,false,100]);
// soundList.push(['disappear','s_disappear',false,false,false,100]);

for (var i=0; i<soundList.length; i++) {
	_root['sound_' + soundList[i][0]] = new Sound(_root);
	var sRef = _root['sound_' + soundList[i][0]];
	sRef.sourcename = soundList[i][1];
	sRef.external = soundList[i][2];
	sRef.looping = soundList[i][3];
	sRef.ambient = soundList[i][4];
	sRef.fadeVolume = soundList[i][5];
	_root.soundLoadQueue.push(sRef);
	soundList[i] = sRef;
}

_root.createEmptyMovieClip('i_soundFader',newMcDepth());

_root.i_soundFader.unfadeSounds = function() { // 'in','out'
	debug_trace('unfadeSounds');
	for (var i in _root.soundList) {
		_root.soundList[i].setVolume(100);
	}
}

_root.i_soundFader.fadeSounds = function(dir) { // 'in','out'
	debug_trace('fadeSounds');
	this.direction = dir;
	this.fadeSteps = _root.soundFadeDuration;
	this.stepCount = 0;
	this.fadeList = [];
	for (var i in _root.soundList) {
		if (_root.soundList[i].fadeVolume < 100) {
			debug_trace(_root.soundList[i].sourcename)
			var tVol = (dir == 'in') ? 100 - _root.soundList[i].fadeVolume : _root.soundList[i].fadeVolume - 100;
			var dVol = (dir == 'in') ? 100 : _root.soundList[i].fadeVolume;
			this.fadeList.push([_root.soundList[i],_root.soundLIst[i].getVolume(),tVol,dVol]);
		}
	}
	this.onEnterFrame = function() { this.fadeStep() };
}

_root.i_soundFader.fadeStep = function() {
	if (this.stepCount <= this.fadeSteps) {
		for (var i in this.fadeList) {
			var newVol = Math.linearTween(this.stepCount,this.fadeList[i][1],this.fadeList[i][2],this.fadeSteps);
			this.fadeList[i][0].setVolume(newVol);
		}
		this.stepCount ++;
	} else {
		for (var i in this.fadeList) {
			this.fadeList[i][0].setVolume(this.fadeList[i][3]);
		}
		this.onEnterFrame = null;
		delete this.fadeList;
		delete this.stepCount;
		delete this.fadeSteps;
	}
}

startSoundtrack = function() {
	debug_trace('startSoundtrack');
	for (var i in _root.soundList) {
		if (!_root.soundList[i].playing && _root.soundList[i].ambient) {
			_root.soundList[i].start(0,1000);
			_root.soundList[i].playing = true;
		}
	}
	_root.soundPlaying = true;
}

stopSoundtrack = function() {
	debug_trace('stopSoundtrack');
	for (var i in _root.soundList) {
		_root.soundList[i].stop();
		_root.soundList[i].playing = false;
	}
	_root.soundPlaying = false;
}

toggleSound = function() {
	debug_trace('toggleASound');
	if (_root.soundPlaying) {
		_root.stopSoundtrack();
	} else {
		_root.startSoundtrack();
	}
}

/* ---------------- CLASSES ------------------- */

Object.registerClass('m_smallbtn',Buttonbox);
Object.registerClass('m_btnClose',Buttonbox);
Object.registerClass('m_btnReplay',Buttonbox);

/* ---------------- FUNCTIONS ------------------- */

debug_trace = function(a) {
	if (debug) {
		trace(a);
	}
}

newMCDepth = function() {
	return depthCount ++;
}

endWait = function() {
	_level0.i_eventQueue.endWait();
}

setButtonHold = function (b) {
	_global.jdgButtonHold = b;
}

returnRandomArray = function(a) {
	var rand,tempArray = [],rtnArray = [];
	tempArray = tempArray.concat(a);
	while (tempArray.length) {
		rand = Math.floor(Math.random() * tempArray.length);
		rtnArray.push(tempArray[rand]);
		tempArray.splice(rand,1);
	}
	return rtnArray;
}

startGame = function() {
	Mouse.show();
	_root.playerMisses = 0;
	_root.currentQuestion = 0;
	_root.setTurnInProgress(false);
	if (_root.firstPlay) {
		_root.loadQueuedSound();
		_root.showBreaker();
	} else {
		for (var i in _root.attachedMcs) { 
			_root.attachedMcs[i].stop(); 
			_root.attachedMcs[i].onEnterFrame = null; 
			_root.attachedMcs[i].removeMovieClip();
		}
		_root.attachedMcs = [];
		_level0.i_eventQueue.addWait(2);
		_level0.i_eventQueue.addEvent(_root,'initMovie',null,false);
		for (var i in _root.soundList) {
			_root.soundList[i].setVolume(100);
		}
	}
}

showBreaker = function() {
	_root.attachNewMc(_root,'m_scr_intro','i_scr_intro');
	_level0.i_eventQueue.addEvent(_root.sound_startScreen,'start',null,false);
	_root.i_scr_intro.onRelease = function() { _root.showBreaker2(); }
}

showBreaker2 = function() {
	_level0.i_eventQueue.addEvent(_root.i_scr_intro,'removeMovieClip',null,false);
	_root.attachNewMc(_root,'m_scr_intro2','i_scr_intro2');
	_level0.i_eventQueue.addEvent(_root.sound_startScreen,'start',null,false);
	_root.i_scr_intro2.onRelease = function() { _root.endBreaker2(); }
}

endBreaker2 = function() {
	_level0.i_eventQueue.addEvent(_root.i_scr_intro2,'tweenTo',[[['_alpha',0]],10],true);
	_level0.i_eventQueue.addEvent(_root.i_scr_intro2,'removeMovieClip',null,false);
	_root.buildXML(xmlFileName,'quizdata');
}

endGame = function() {
	getURL('javascript:self.close();');
}

showOgolPage = function(l) {
	getURL("http://alertaenlinea.gov/parepiensehagaclic.html","_blank");
}

replayGame = function() {
	_global.jdgButtonHold = false;
	_root.firstPlay = false;
	startGame();
}

attachNewMc = function(mc,libname,instname) {
	if (libname != null) {
		mc.attachMovie(libname,instname,newMCDepth() );
	} else {
		mc.createEmptyMovieClip(instname,newMcDepth() );
	}
	_root.attachedMcs.push(_root[instname]);
}

buildXML = function(a,name) {	// create XML object from file
	debug_trace('buildXML');
	_root[name] = new XML();
	_root[name].ignoreWhite = true;
//	_root[name].onLoad = _root.xmlloadingDone;
	_root[name].onLoad = function(success) {
		debug_trace('xmlLoadingDone');
		initMovie();
	}
	_root[name].load(a + '.xml');
}

xmlLoadingDone = function(b) {
	debug_trace('xmlLoadingDone');
	initMovie();
}

answerboxClicked = function(box) {
	debug_trace('answerboxClicked');
	for (var i in _root.i_qubox.answerMcs) {
		_root.i_qubox.answerMcs[i].kill();
	}
	_root.i_qubox.i_explanationText.htmlText = box.explanationText;
	_root.i_qubox.i_explanationText.hide();
	_root.lastAnswer = box.correct;
	if (box.correct) {
		if (_root.soundPlaying) {
			debug_trace('sound_correct');
			_level0.i_eventQueue.addEvent(_root.sound_correct,'start',null,false);
		}
	} else {
		if (_root.soundPlaying) {
			debug_trace('sound_incorrect');
			_level0.i_eventQueue.addEvent(_root.sound_incorrect,'start',null,false);
		}
		_root.i_qubox.i_explanationText.setTextFormat(_root.explanationIncorrectTf);
	}
	_root.i_qubox.i_explanationText.setTextFormat(_root.explanationTf);
	_root.i_qubox.i_explanationText.italicize (_root.explanationItalicTf);
	_level0.i_eventQueue.addWait(10);
	_level0.i_eventQueue.addEvent(_root.i_qubox.i_explanationText,'show',null,false);
	_level0.i_eventQueue.addWait(10);
	_level0.i_eventQueue.addEvent(_root.i_qubox.i_buttonContinue,'show',null,false);
}

continueButtonClicked = function() {
	_root.endQuestion();
//	_root.i_soundFader.unfadeSounds();
}

showQuestionBg = function() {
	debug_trace('showQuestionBg');
	_root.i_qubox.i_text.htmlText = '';
	_root.i_qubox._xscale = 10;
	_root.i_qubox._yscale = 10;
	_root.i_qubox._alpha = 0;
	_root.i_qubox.show();

	var tweenArray = [];
	tweenArray.push(['_x',_root.quboxPos[0]]);
	tweenArray.push(['_y',_root.quboxPos[1]]);
	tweenArray.push(['_xscale',100]);
	tweenArray.push(['_yscale',100]);
	tweenArray.push(['_alpha',100]);

	_level0.i_eventQueue.addEvent(_root.i_qubox,'tweenTo',[tweenArray,10],true);
	_level0.i_eventQueue.addEvent(_root.i_soundFader,'fadeSounds','out',false);
}

endQuestion = function() {
	debug_trace('endQuestion');
	
	// remove current question
	_root.unansweredQuestions.removeValue(_root.currentQuestion);
	
	_level0.i_eventQueue.addEvent(_root.i_qubox,'tweenTo',[[['_alpha',0]],10],true);
	for (var i in _root.i_qubox.answerMcs) {
		_root.i_qubox.answerMcs[i].removeMovieClip();
	}
	_root.i_qubox.i_questionText.htmlText = '';
	_root.i_qubox.i_explanationText.htmlText = '';
	_root.i_qubox.i_buttonContinue.hide();
	_level0.i_eventQueue.addEvent(_root.i_qubox,'hide',null,false);
//	process answer
	if (_root.lastAnswer) { // correct
//		_level0.i_eventQueue.addEvent(_root.i_spy,'tweenTo',[[['_alpha',100]],10],true);
		_root.i_screens['i_scr'+_root.currentQuestion].i_tip.show();
		_root.i_screens['i_scr'+_root.currentQuestion].i_bgC.show();
		_level0.i_eventQueue.addEvent(_root.i_spy,'show',false);
		_level0.i_eventQueue.addEvent(_root.i_spy,'tweenTo',[[['_alpha',100]],5],true);
		_level0.i_eventQueue.addEvent(_root,'setButtonHold',false,false);
		_root.attachNewMc(_root,'m_instructions_2','i_instructions_2');
		_root.i_instructions_2._alpha=0;
		_level0_root.i_eventQueue.addWait(5);
		_level0_root.i_eventQueue.addEvent(_root.i_instructions_2,'tweenTo',[[['_alpha',100]],10],true);
	} else { // incorrect
		_root.playerMisses++;
		_level0.i_eventQueue.addEvent(_root.i_soundFader,'fadeSounds','in',false);
		_root.i_screens['i_scr'+_root.currentQuestion].i_tip.show();
		_root.i_screens['i_scr'+_root.currentQuestion].i_bgI.show();
		_root.endQuestion2();
	}
//	proceed
}

endQuestion2 = function() {
	if (_root.unansweredQuestions.length) {
		if (_root.lastAnswer) {
			for (var i in _root.spyTools) {
				var lbl = _root.spyTools[i];
				_root.i_spy['i_'+lbl].i_glow.hide();
				_root.i_spy.i_text['i_'+lbl].hide();
			}
			_level0.i_eventQueue.addEvent(_root.i_soundFader,'fadeSounds','in',false);
			_level0.i_eventQueue.addEvent(_root.i_spy,'tweenTo',[[['_alpha',0]],5],true);
			_level0.i_eventQueue.addEvent(_root.i_spy,'hide',false);
			_level0.i_eventQueue.addEvent(_root,'setButtonHold',false,false);
		}
		_root.startFaces();
		
	} else {
		_level0.i_eventQueue.addEvent(_root,'showEnding',null,false);
	}
}

showAnswerBox = function(obj) {
	_level0.i_eventQueue.addEvent(obj,'tweenTo',[[['_alpha',100]],3],true);
}

showQuestion = function(num) {
	debug_trace('showQuestion: ' + num);
	_root.currentQuestion = num;

	var qNode = _root.quizdata.firstChild.childNodes[num-1];
	var questionType = qNode.attributes.questionType;
	var ySpace =(questionType == 'boolean') ? _root.answerBoxYSpacing * 2 : _root.answerBoxYSpacing;
	
	var qText = qNode.firstChild.firstChild.nodeValue;
	
	_root.i_qubox.i_questionText.htmlText = qText;
	_root.i_qubox.i_questionText.setTextFormat(_root.questionTf);
	_root.i_qubox.i_questionText.italicize (_root.questionItalicTf);
	_root.i_qubox.i_questionText._height = _root.i_qubox.i_questionText.textHeight + 6;
	var yCursor = _root.i_qubox.i_questionText._y + _root.i_qubox.i_questionText._height + ySpace;
	
	_level0.i_eventQueue.addEvent(_root.sound_question,'start',null,false);
	_level0.i_eventQueue.addWait(10);
	showQuestionBg();

	for (var i = 0; i < qNode.childNodes[1].childNodes.length; i ++) {
		var ansText = qNode.childNodes[1].childNodes[i].firstChild.firstChild.nodeValue;
		var explText = qNode.childNodes[1].childNodes[i].childNodes[1].firstChild.nodeValue;
		var ansCorrect = qNode.childNodes[1].childNodes[i].attributes.correct;

		attachNewMc(_root.i_qubox,'m_ansbox','i_ansbox'+i);
		var o = _root.i_qubox['i_ansbox'+i];
		_root.i_qubox.answerMcs.push(o);
		o.propOnRelease = _root.answerBoxClicked;
		o.bgColors = _root.ansboxBgColors;
		o.olColors = _root.ansboxOlColors;
		if (questionType == 'boolean') {
			o.textFormat = _root.ansboxBoolTf;
		} else {
			o.textFormat = _root.ansboxTf;
		}
		o.textColors = _root.ansboxTextColors;
		o.textPadding = _root.answerTextPadding;
		o.correct = (ansCorrect == "true") ? true : false;
		o.answerText = ansText;
		o.italicize (_root.ansboxItalicTf);
		o.explanationText = explText;
		o._x = _root.answerBoxIndent;
		o._y = yCursor;
		yCursor += o._height + ySpace;
		o._alpha = 0;
		
//		_level0.i_eventQueue.addEvent(o,'tweenTo',[[['_alpha',100]],3],true);
		showAnswerBox(o);
	}

	_root.i_qubox.i_explanationText._y = yCursor;
	yCursor += _root.i_qubox.i_explanationText._height + ySpace;
}

beginTurn = function() {
	debug_trace('--------\nbeginTurn');
	_root.setTurnInProgress(true);
	
	if (_root.soundPlaying) {

	}
	_root.showNextQuestion();

}

showEnding = function() {
	debug_trace('showEnding');
	_root.attachNewMc(_root,'m_scr_ending','i_scr_ending');
	_root.i_scr_ending._alpha = 0;
	_root.i_scr_ending.hide();
	if (_root.playerMisses < 2) {
		_root.i_scr_ending.gotoAndStop(1);
	} else {
		_root.i_scr_ending.gotoAndStop(2);
	}
	
	_root.attachNewMc(_root.i_scr_ending,'m_btnReplay','i_btnReplay');
	_root.i_scr_ending.i_btnReplay.moveToA([40,445]);
	_root.i_scr_ending.i_btnReplay.bgColors = _root.barbtnBgColors;
	_root.i_scr_ending.i_btnReplay.olColors = _root.barbtnOlColors;
	_root.i_scr_ending.i_btnReplay.textColors = _root.barbtnTextColors;
	_root.i_scr_ending.i_btnReplay.onRelease = function() { _root.replayGame(); }

	_root.attachNewMc(_root.i_scr_ending,'m_btnClose','i_btnClose');
	_root.i_scr_ending.i_btnClose.moveToA([120,445]);
	_root.i_scr_ending.i_btnClose.bgColors = _root.barbtnBgColors;
	_root.i_scr_ending.i_btnClose.olColors = _root.barbtnOlColors;
	_root.i_scr_ending.i_btnClose.textColors = _root.barbtnTextColors;
	_root.i_scr_ending.i_btnClose.onRelease = function() { _root.endGame(); }

	if (!_root.lastQuestion) {
		_root.setButtonHold(true);
		_level0.i_eventQueue.addEvent(_root.i_spy,'show',false);
		_level0.i_eventQueue.addEvent(_root.i_spy,'tweenTo',[[['_alpha',100]],5],true);
	}

	_level0.i_eventQueue.addEvent(_root.i_screens,'tweenTo',[[['_alpha',0]],10],false);
	_level0.i_eventQueue.addEvent(_root.i_gameBg2,'tweenTo',[[['_alpha',0]],10],false);
	_level0.i_eventQueue.addEvent(_root.i_scr_ending,'show',null,false);
	_level0.i_eventQueue.addEvent(_root.i_scr_ending,'tweenTo',[[['_alpha',100]],10],true);
	if (_root.soundPlaying) {
		_level0.i_eventQueue.addEvent(_root,'stopSoundtrack',null,false);
		_level0.i_eventQueue.addWait(10);
		_level0.i_eventQueue.addEvent(_root.sound_ending,'start',null,false);
		_root.restartSoundOnReplay = true;
	}
}

startFaces = function() {
	debug_trace('startFaces');
	_root.unansweredQuestions.randomize();
	faceFlashInterval = setInterval(_root.flashNextFace,_root.faceFlashRate);
	_root.attachNewMc(_root,'m_instructions_1','i_instructions_1');
	_root.i_instructions_1._alpha=0;
	_level0_root.i_eventQueue.addWait(5);
	_level0_root.i_eventQueue.addEvent(_root.i_instructions_1,'tweenTo',[[['_alpha',100]],10],true);
}

flashNextFace = function() {
	debug_trace('flashNextFace');
	clearInterval(faceFlashInterval);
	var oldFace = _root.unansweredQuestions.shift();
	_root.unansweredQuestions.push(oldFace);
	var newFace = _root.unansweredQuestions[0];
	_root.i_screens['i_scr'+oldFace].i_face.hide();
	_root.i_screens['i_scr'+newFace].i_face.show();
	_root.i_screens['i_scr'+newFace].i_face.onRelease = function() { 
		_level0_root.i_eventQueue.addEvent(_root.i_instructions_1,'removeMovieClip',null,false);
		_root.showQuestion(newFace);
		_root.stopFaces(); }
	faceFlashInterval = setInterval(_root.flashNextFace,_root.faceFlashRate);
}

stopFaces = function() {
	clearInterval(faceFlashInterval);
	var oldFace = _root.unansweredQuestions[0];
	_root.i_screens['i_scr'+oldFace].i_face.hide();
}

/* ---------------- MOVIE INITIALIZATION ------------------- */

initMovie = function() {
	debug_trace('initMovie');

	_root.i_breaker.removeMovieClip();
	
	_root.unansweredQuestions = [1,2,3,4,5,6,7];
	_root.spyTools = ['camera','watch','tie','gps','pen','radio','glasses'];

	if (_root.restartSoundOnReplay) {
		_root.startSoundtrack();
	}

	// draw game board
	
	_root.attachNewMc(_root,'m_gameBg','i_gameBg');
	_root.attachNewMc(_root,'m_gameBg2','i_gameBg2');

	_root.attachNewMc(_root,'m_screens','i_screens');
	for (var i=1; i<8; i++) {
		i_screens['i_scr'+i].i_face.hide();
		i_screens['i_scr'+i].i_tip.hide();
		i_screens['i_scr'+i].i_bgI.hide();
		i_screens['i_scr'+i].i_bgC.hide();
	}

	_root.attachNewMc(_root,'m_sidebar','i_sidebar');

	_root.attachNewMc(_root,'m_spyNc','i_spyNc');
	
	_root.attachNewMc(_root,'m_spy','i_spy');
	_root.i_spy.hide();
	for (var i in _root.spyTools) {
		var lbl = _root.spyTools[i];
		_root.i_spy['i_'+lbl].label = lbl;
		_root.i_spy['i_'+lbl].i_glow.hide();
		_root.i_spy.i_text['i_'+lbl].hide();
		_root.i_spy['i_'+lbl].onRollOver = function () {
			if (!_global.jdgButtonHold) {
				this.i_glow.show();
				_root.i_spy.i_text['i_'+this.label].show();
			}
		};
		_root.i_spy['i_'+lbl].onRollOut = function () {
			if (!_global.jdgButtonHold) {
				this.i_glow.hide();
				_root.i_spy.i_text['i_'+this.label].hide();
			}
		};
		_root.i_spy['i_'+lbl].onRelease = function () {
			if (!_global.jdgButtonHold) {
			_root.i_spy.i_text['i_'+this.label].hide();
				_level0.i_eventQueue.addEvent(_root,'setButtonHold',true,false);
				_level0_root.i_eventQueue.addEvent(_root.i_instructions_2,'removeMovieClip',null,false);
				_level0.i_eventQueue.addEvent(this,'tweenTo',[[['_alpha',0]],5],true);
				_level0.i_eventQueue.addEvent(this,'hide',false,false);
				_level0.i_eventQueue.addWait(25);
				_level0.i_eventQueue.addEvent(_root,'endQuestion2',null,false);
			}
		}

	}

	// set up sound button
	_root.attachNewMc(_root,'m_b_sound','i_buttonSound');
	_root.i_buttonSound.moveToA([605,450]);
	_root.i_buttonSound.gotoAndStop(_root.soundPlaying ? 1 : 3);
	_root.i_buttonSound.onRelease = function() {
		_root.toggleSound();
		this.gotoAndStop(_root.soundPlaying ? 1 : 3);
	}
	_root.i_buttonSound.onRollOver = function() {
		this.gotoAndStop(_root.soundPlaying ? 2 : 4);
	}
	_root.i_buttonSound.onRollOut = function() {
		this.gotoAndStop(_root.soundPlaying ? 1 : 3);
	}

	// set up question box
	
	_root.attachNewMc(_root,'m_qubox','i_qubox');
	_root.i_qubox.hide();
	_root.i_qubox.answerMcs = [];
	
	_root.attachNewMc(_root.i_qubox,'m_smallbtn','i_buttonContinue');
	_root.i_qubox.i_buttonContinue.moveToA(_root.continueButtonPos);
//	_root.i_qubox.i_buttonContinue.__proto__ = Buttonbox.prototype;
	_root.i_qubox.i_buttonContinue.bgColors = _root.contbtnBgColors;
	_root.i_qubox.i_buttonContinue.olColors = _root.contbtnOlColors;
	_root.i_qubox.i_buttonContinue.textColors = _root.contbtnTextColors;
	_root.i_qubox.i_buttonContinue.hide();
	_root.i_qubox.i_buttonContinue.onRelease = function() { _root.continueButtonClicked(); }

	_root.i_qubox.createTextField('i_questionText',1,_root.questionTextPadding,_root.questionTextPadding * .6,_root.i_qubox._width - (_root.questionTextPadding * 2),_root.i_qubox._height * 4);
	var o = _root.i_qubox.i_questionText;
	o.multiline = true;
	o.wordWrap = true;
	o.embedFonts = true;
	o.selectable = false;
	o.html = true;
	o.setNewTextFormat(_root.questionTf);
	
	_root.i_qubox.createTextField('i_explanationText',2,_root.questionTextPadding,480,_root.i_qubox._width - (_root.questionTextPadding * 2),_root.i_qubox._height * 4);
	var p = _root.i_qubox.i_explanationText;
	p.multiline = true;
	p.wordWrap = true;
	p.embedFonts = true;
	p.selectable = false;
	p.html = true;
	p.setNewTextFormat(_root.explanationTf);
	p.hide();

	_level0.i_eventQueue.addWait(_root.i_gameBg2._totalframes);
	_level0.i_eventQueue.addEvent(_root,'startFaces',null,false);
	
//	showNextQuestion();
	
}


/* ---------------- RUNTIME ------------------- */

if (_root == _level0) { 
	startGame();
}
